/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-saphari-msgs-0.0.5-0raring-20150424-1754/msg/Human.msg
 *
 */


#ifndef SAPHARI_MSGS_MESSAGE_HUMAN_H
#define SAPHARI_MSGS_MESSAGE_HUMAN_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <saphari_msgs/BodyPart.h>

namespace saphari_msgs
{
template <class ContainerAllocator>
struct Human_
{
  typedef Human_<ContainerAllocator> Type;

  Human_()
    : header()
    , userID(0)
    , bodyParts()  {
    }
  Human_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , userID(0)
    , bodyParts(_alloc)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef int32_t _userID_type;
  _userID_type userID;

   typedef std::vector< ::saphari_msgs::BodyPart_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::saphari_msgs::BodyPart_<ContainerAllocator> >::other >  _bodyParts_type;
  _bodyParts_type bodyParts;




  typedef boost::shared_ptr< ::saphari_msgs::Human_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::saphari_msgs::Human_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Human_

typedef ::saphari_msgs::Human_<std::allocator<void> > Human;

typedef boost::shared_ptr< ::saphari_msgs::Human > HumanPtr;
typedef boost::shared_ptr< ::saphari_msgs::Human const> HumanConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::saphari_msgs::Human_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::saphari_msgs::Human_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace saphari_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'saphari_msgs': ['/tmp/buildd/ros-hydro-saphari-msgs-0.0.5-0raring-20150424-1754/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::saphari_msgs::Human_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::saphari_msgs::Human_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::saphari_msgs::Human_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::saphari_msgs::Human_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::saphari_msgs::Human_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::saphari_msgs::Human_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::saphari_msgs::Human_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ac2898d26bbaca91f5b87a7d91b448c6";
  }

  static const char* value(const ::saphari_msgs::Human_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xac2898d26bbaca91ULL;
  static const uint64_t static_value2 = 0xf5b87a7d91b448c6ULL;
};

template<class ContainerAllocator>
struct DataType< ::saphari_msgs::Human_<ContainerAllocator> >
{
  static const char* value()
  {
    return "saphari_msgs/Human";
  }

  static const char* value(const ::saphari_msgs::Human_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::saphari_msgs::Human_<ContainerAllocator> >
{
  static const char* value()
  {
    return "std_msgs/Header header\n\
int32 userID \n\
BodyPart[] bodyParts\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: saphari_msgs/BodyPart\n\
uint8 LEFTFOOT=0\n\
uint8 LEFTLEG=1\n\
uint8 LEFTKNEE=2\n\
uint8 LEFTTHIGH=3\n\
uint8 RIGHTFOOT=4\n\
uint8 RIGHTLEG=5\n\
uint8 RIGHTKNEE=6\n\
uint8 RIGHTTHIGH=7\n\
uint8 RIGHTHIP=8\n\
uint8 LEFTHIP=9\n\
uint8 NECK=10\n\
uint8 RIGHTARM=11\n\
uint8 RIGHTELBOW=12\n\
uint8 RIGHTFOREARM=13\n\
uint8 RIGHTHAND=14\n\
uint8 LEFTARM=15\n\
uint8 LEFTELBOW=16\n\
uint8 FOREARM=17\n\
uint8 LEFTHAND=18\n\
uint8 LEFTBOTTOMFACE=19\n\
uint8 RIGHTBOTTOMFACE=20\n\
uint8 LEFTTOPFACE=21\n\
uint8 RIGHTTOPFACE=22\n\
uint8 RIGHTCHEST=23\n\
uint8 LEFTCHEST=24\n\
\n\
#following ids are the backup for the demo using the ni tracker\n\
uint8 HEAD=96\n\
uint8 TORSO=97\n\
uint8 RIGHTSHOULDER=98\n\
uint8 LEFTSHOULDER=99\n\
\n\
int32 id\n\
int32 label\n\
int32[] childIDs\n\
geometry_msgs/Point32 centroid\n\
float32 radius\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point32\n\
# This contains the position of a point in free space(with 32 bits of precision).\n\
# It is recommeded to use Point wherever possible instead of Point32.  \n\
# \n\
# This recommendation is to promote interoperability.  \n\
#\n\
# This message is designed to take up less space when sending\n\
# lots of points at once, as in the case of a PointCloud.  \n\
\n\
float32 x\n\
float32 y\n\
float32 z\n\
";
  }

  static const char* value(const ::saphari_msgs::Human_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::saphari_msgs::Human_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.userID);
      stream.next(m.bodyParts);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Human_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::saphari_msgs::Human_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::saphari_msgs::Human_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "userID: ";
    Printer<int32_t>::stream(s, indent + "  ", v.userID);
    s << indent << "bodyParts[]" << std::endl;
    for (size_t i = 0; i < v.bodyParts.size(); ++i)
    {
      s << indent << "  bodyParts[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::saphari_msgs::BodyPart_<ContainerAllocator> >::stream(s, indent + "    ", v.bodyParts[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // SAPHARI_MSGS_MESSAGE_HUMAN_H
